import java.awt.*;
import java.io.*;

//---------Advanced Options Dialog------------------------------------------------------------------

public class AdvOptions extends Dialog
{
	public AdvOptions(Frame parent)
	{
		super(parent, "Advanced TETware Options", true);
	//	setTitle("Advanced TETware Options");
		setResizable(false);
		
		tabs = new Panel();
		tabs.setBackground(Color.gray);
		tabs.add(new Button("Run options"));
		tabs.add(new Button("Alternative file settings"));
		tabs.add(new Button("Alternative directory settings"));
		tabs.add(new Button("More options"));
		add("North", tabs);
	
		cards = new Panel();
		cards.setBackground(Color.lightGray);
		layout = new CardLayout();
		cards.setLayout(layout);

		cards.add("Run options", new ROptions("Run options"));
		cards.add("Alternative file settings", new FOptions("Alternative file settings"));
		cards.add("Alternative directory settings", new DOptions("Alternative directory settings"));
		cards.add("More options", new MOptions("More options"));
		add("Center", cards);

		enter = new Panel();
		enter.setBackground(Color.lightGray);
		enter.add(new Button("OK"));
		enter.add(new Button("Apply"));
		enter.add(new Button("Cancel"));
		enter.add(new Button("Clear all options"));
		add("South", enter);
		setSize(600,320);
	}

	private Panel cards;
	private Panel tabs;
	private Panel enter;
	private CardLayout layout;

//---------handle actions----------------------------------------------------------------
	
	public boolean action(Event evt, Object arg)
	{
		boolean fileExistJ = false;
		boolean fileExistOJ = false;

		if(evt.target instanceof Component &&
		  ((Component) evt.target).getParent().equals(tabs))
		{
			layout.show(cards, (String) arg);
			return true;
		}

		if(evt.target instanceof Checkbox)
		{
			if("Normal".equals(((Checkbox)evt.target).getLabel()))
			{
				browse.setEnabled(false);	
				l.setEnabled(false);
				l.deselect(0);
				l.deselect(1);
				l.deselect(2);
				textFieldOJ.setEnabled(false);
				textFieldM.setEnabled(false);
				checkboxOM.setEnabled(false);
				checkboxRC.setEnabled(false);
			}

			if("Resume".equals(((Checkbox)evt.target).getLabel()))
			{
				setComp(checkboxM);
				setCodeListComponents();
			}

			if("Re-run".equals(((Checkbox)evt.target).getLabel()))
			{
				setComp(checkboxR);
				setCodeListComponents();
			}

			if("tcc operation modes:".equals(((Checkbox)evt.target).getLabel()))
			{
				setCodeListComponents();
			}

			if("test purpose result code names".equals(((Checkbox)evt.target).getLabel()))
			{
				setCodeListComponents();
			}

			if("-a Execution Directory  ".equals(((Checkbox)evt.target).getLabel()))
				checkboxAction(textFieldA, checkboxA, buttonA);
			if("-l Process Scenario line        ".equals(((Checkbox)evt.target).getLabel()))
				checkboxAction(textAreaL, checkboxL);
			if("-n Do not process these test cases".equals(((Checkbox)evt.target).getLabel()))
			{
				checkboxAction(textAreaY, checkboxY);
				checkboxAction(textAreaN, checkboxN);
			}
			if("-y Only process these test cases  ".equals(((Checkbox)evt.target).getLabel()))
			{
				checkboxAction(textAreaY, checkboxY);
				checkboxAction(textAreaN, checkboxN);
			}
			if("None".equals(((Checkbox)evt.target).getLabel()))
			{
				checkboxAction(textAreaY, checkboxY);
				checkboxAction(textAreaN, checkboxN);
			}
			if("-v set configuration variable   ".equals(((Checkbox)evt.target).getLabel()))
				checkboxAction(textAreaV, checkboxV);
			if("-i Journal Directory    ".equals(((Checkbox)evt.target).getLabel()))
				checkboxAction(textFieldI, checkboxI, buttonI);
			if("-s   Scenario file                  ".equals(((Checkbox)evt.target).getLabel()))
				checkboxAction(textFieldS, checkboxS, buttonS);
			if("-j   Journal file                   ".equals(((Checkbox)evt.target).getLabel()))
				checkboxAction(textFieldJ, checkboxJ, buttonJ);
			if("-g   Build mode configuration file  ".equals(((Checkbox)evt.target).getLabel()))
				checkboxAction(textFieldG, checkboxG, buttonG);
			if("-x   Execute mode configuration file".equals(((Checkbox)evt.target).getLabel()))
				checkboxAction(textFieldX, checkboxX, buttonX);
			if("-f   Clean mode configuration file  ".equals(((Checkbox)evt.target).getLabel()))
				checkboxAction(textFieldF, checkboxF, buttonF);
		}
		if(evt.target==browse)
		{
			FileDialog od = new FileDialog(new Tetv3_gui(), "Open...", FileDialog.LOAD);
			od.show();
			System.out.println("dir is " + od.getDirectory());
			System.out.println("file is " + od.getFile());
			if(od.getFile()!=null)
				textFieldOJ.setText(od.getDirectory() + od.getFile());
		}			
		if(evt.target==buttonS)
		{
			FileDialog od = new FileDialog(new Tetv3_gui(), "Open...", FileDialog.LOAD);
			od.show();
			System.out.println("dir is " + od.getDirectory());
			System.out.println("file is " + od.getFile());
			if(od.getFile()!=null)
				textFieldS.setText(od.getDirectory() + od.getFile());
		}		
		if(evt.target==buttonJ)	
		{
			FileDialog od = new FileDialog(new Tetv3_gui(), "Open...", FileDialog.LOAD);
			od.show();
			System.out.println("dir is " + od.getDirectory());
			System.out.println("file is " + od.getFile());
			if(od.getFile()!=null)
				textFieldJ.setText(od.getDirectory());
		}		
	
		if(evt.target==buttonG)		
		{
			FileDialog od = new FileDialog(new Tetv3_gui(), "Open...", FileDialog.LOAD);
			od.show();
			System.out.println("dir is " + od.getDirectory());
			System.out.println("file is " + od.getFile());
			if(od.getFile()!=null)
				textFieldG.setText(od.getDirectory() + od.getFile());
		}		
		if(evt.target==buttonX)		
		{
			FileDialog od = new FileDialog(new Tetv3_gui(), "Open...", FileDialog.LOAD);
			od.show();
			System.out.println("dir is " + od.getDirectory());
			System.out.println("file is " + od.getFile());
			if(od.getFile()!=null)
				textFieldX.setText(od.getDirectory() + od.getFile());
		}		
		if(evt.target==buttonF)		
		{
			FileDialog od = new FileDialog(new Tetv3_gui(), "Open...", FileDialog.LOAD);
			od.show();
			System.out.println("dir is " + od.getDirectory());
			System.out.println("file is " + od.getFile());
			if(od.getFile()!=null)
				textFieldF.setText(od.getDirectory() + od.getFile());
		}		
		if(evt.target==buttonA)		
		{
			FileDialog od = new FileDialog(new Tetv3_gui(), "Open...", FileDialog.LOAD);
			od.show();
			System.out.println("dir is " + od.getDirectory());
			System.out.println("file is " + od.getFile());
			if(od.getFile()!=null)
				textFieldA.setText(od.getDirectory());
		}		
		if(evt.target==buttonI)		
		{
			FileDialog od = new FileDialog(new Tetv3_gui(), "Open...", FileDialog.LOAD);
			od.show();
			System.out.println("dir is " + od.getDirectory());
			System.out.println("file is " + od.getFile());
			if(od.getFile()!=null)
				textFieldI.setText(od.getDirectory());
		}			

		if(arg.equals("OK"))
		{
			noMRoptions = false;
			disposeFlag = true;
			oldJournalFlag = true;
			fileExistJ = (new File(textFieldJ.getText())).exists();		//Alternative Journal file
			fileExistOJ = (new File(textFieldOJ.getText())).exists();	//Old Journal File
			if(fileExistJ)		
			{
				FileExistsDialog fed = new FileExistsDialog(new Tetv3_gui());
				fed.show();
				return true;
			}

			if((fileExistOJ == false) && (checkboxNm.getState()==false))
			{
				FileExistsDialog fed = new FileExistsDialog(new Tetv3_gui(), 1);
				fed.show();
				return true;
			}
			
			getRunOptions(checkboxR,stateR);
			getRunOptions(checkboxM,stateM);
			vOpCheck(textAreaV.getText());
			advop="";
			if(noMRoptions)
				return true;
			if(disposeFlag && oldJournalFlag && (fileExistJ==false) && (fileExistOJ || checkboxNm.getState()))
			{
				setAndWriteOptions();
				dispose();
			}else if(disposeFlag == false){
				WrongFormatDialog wfd = new WrongFormatDialog(new Tetv3_gui());
				wfd.show();
			}				
			return true;
		}

		if(arg.equals("Apply"))
		{
			noMRoptions = false;
			disposeFlag = true;
			fileExistJ = (new File(textFieldJ.getText())).exists();
			fileExistOJ = (new File(textFieldOJ.getText())).exists();
			if(fileExistJ)
			{
				FileExistsDialog fed = new FileExistsDialog(new Tetv3_gui());
				fed.show();
				return true;
			}

			if((fileExistOJ == false) && (checkboxNm.getState()==false))
			{
				FileExistsDialog fed = new FileExistsDialog(new Tetv3_gui(), 1);
				fed.show();
				return true;
			}

			getRunOptions(checkboxR,stateR);
			getRunOptions(checkboxM,stateM);
			vOpCheck(textAreaV.getText());
			advop="";
			if(noMRoptions)
				return true;

			if(disposeFlag && oldJournalFlag && (fileExistJ==false) && (fileExistOJ || checkboxNm.getState()))
			{
				setAndWriteOptions();
				return true;
			}else if(disposeFlag == false){
				WrongFormatDialog wfd = new WrongFormatDialog(new Tetv3_gui());
				wfd.show();
				return true;
			}else{
				return true;
			}
		}

		if(arg.equals("Cancel"))
		{
			dispose();
			return true;
		}

		if(arg.equals("Clear all options"))
		{
		//	disableComponents(checkboxS, textFieldS, buttonS);
			disableComponents(checkboxG, textFieldG, buttonG);
			disableComponents(checkboxJ, textFieldJ, buttonJ);
			disableComponents(checkboxX, textFieldX, buttonX);
			disableComponents(checkboxF, textFieldF, buttonF);
			disableComponents(checkboxA, textFieldA, buttonA);
			disableComponents(checkboxI, textFieldI, buttonI);
			disableComponents(checkboxL, textAreaL);
			disableComponents(checkboxN, textAreaN);
			disableComponents(checkboxY, textAreaY);
			disableComponents(checkboxV, textAreaV);
			browse.setEnabled(false);	
			l.setEnabled(false);
			l.deselect(0);
			l.deselect(1);
			l.deselect(2);
			textFieldOJ.setEnabled(false);
			textFieldOJ.setText("");
			textFieldM.setEnabled(false);
			textFieldM.setText("");
			checkboxNm.setState(true);
			checkboxNone.setState(true);

			return true;
		}
			
		else
			return super.action(evt, arg);
	}

	public void disableComponents(Checkbox cb, TextField tf, Button b)
	{
		cb.setState(false);
		tf.setText("");
		tf.setEditable(false);
		tf.setEnabled(false);
		b.setEnabled(false);
	}

	public void disableComponents(Checkbox cb, TextField tf)
	{
		cb.setState(false);
		tf.setText("");
		tf.setEditable(false);
		tf.setEnabled(false);
	}

	public void disableComponents(Checkbox cb, TextArea ta)
	{
		cb.setState(false);
		ta.setText("");
		ta.setEditable(false);
		ta.setEnabled(false);
	}

	public void setCodeListComponents()
	{
		checkboxOM.setEnabled(true);
		checkboxRC.setEnabled(true);
		if(checkboxOM.getState()==true)
		{
			l.setEnabled(true);
			textFieldM.setText("");
			textFieldM.setEnabled(false);
			textFieldM.setEditable(false);
		}else{
			l.setEnabled(false);
			l.deselect(0);
			l.deselect(1);
			l.deselect(2);
			textFieldM.setEnabled(true);
			textFieldM.setEditable(true);
		}
	}

	public void setAndWriteOptions()
	{
			advop="";
			advop = setAdvOptions();
			strS = setStrS(textFieldS, checkboxS,  "-s ");
			advop+="\n";
			try
			{
				FileOutputStream fos = new FileOutputStream("AdvOp");
				PrintStream ps = new PrintStream(fos);
			//	if(advop.compareTo("")==0)
			//		System.out.println("advop is empty");
				ps.print(advop);
				fos.close();

				FileOutputStream fos2 = new FileOutputStream("ScenF");
				PrintStream ps2 = new PrintStream(fos2);
				ps2.print(strS);
				fos2.close();

			}
			catch(IOException e)
			{
				System.out.println("Problems writing to file " + e);
			}
	}

	public void checkboxAction(TextField tf, Checkbox cb, Button b)
	{
	//	System.out.println(cb + " checkbox clicked");

		if(cb.getState() == true)
		{				
			tf.setEditable(true);
			tf.setEnabled(true);
			b.setEnabled(true);
		}else{
			tf.setEditable(false);
			tf.setEnabled(false);
			b.setEnabled(false);							
		}
	}

	public void checkboxAction(TextField tf, Checkbox cb)
	{
	//	System.out.println(cb + " checkbox clicked");

		if(cb.getState() == true)
		{				
			tf.setEditable(true);
			tf.setEnabled(true);
		}else{
			tf.setEditable(false);
			tf.setEnabled(false);
		}
	}

	public void checkboxAction(TextArea ta, Checkbox cb)
	{
	//	System.out.println(cb + " checkbox clicked");

		if(cb.getState() == true)
		{
			ta.setEditable(true);
			ta.setEnabled(true);
		}else{
			ta.setEditable(false);
			ta.setEnabled(false);
		}
	}

	public void getFieldText(TextField tf, Checkbox cb, String option)
	{
		String field = tf.getText();

		if(field.compareTo("")>0)			//check textfield for a string		
		{
			if(cb.getState()==true)			//if checkbox is true
				advop += option + field.trim() + " " + " **! ";	//! indicates checkbox is true
			else
				advop += option + field.trim() + " " + " ** ";
		}else{
			advop+= "";
		//	System.out.println("textfield " + option + " is empty " + field);
		}
	}

	public void getAreaText(TextArea ta, Checkbox cb, String option)
	{
		String field = ta.getText().trim();
		String tmpStr;
		if(field.compareTo("")>0)			//check textfield for a string		
		{
			if(cb.getState()==true)			//if checkbox is true
			{
				while(field.compareTo("")!=0)
				{
					while(field.indexOf('\n') != -1)
					{			
						if(option.compareTo("-l ")==0)
							advop += option + "\"" + field.substring(0,field.indexOf('\n')).trim() + "\"" + " **! ";	//! indicates checkbox is true
						else if(option.compareTo("-v ")==0)
							{
							tmpStr = vOpCheck(field.substring(0,field.indexOf('\n')).trim());
							if(disposeFlag)								
								advop += option  + tmpStr + " **! ";	//! indicates checkbox is true
							else
								advop +="";
							}
						else
							advop += option + field.substring(0,field.indexOf('\n')).trim() + " **! ";	//! indicates checkbox is true
						field = field.substring(field.indexOf('\n') + 1);
					}
					if(option.compareTo("-l ")==0)
						advop += option + "\"" + field.trim() + "\"" + " **! ";	//! indicates checkbox is true
					else if(option.compareTo("-v ")==0)
						{
						tmpStr = vOpCheck(field.trim());
						if(disposeFlag)								
							advop += option  + tmpStr + " **! ";	//! indicates checkbox is true
						else
							advop +="";
						}

					else
						advop += option + field.trim() + " **! ";	//! indicates checkbox is true
					field = "";
				}
			}else{
				while(field.compareTo("")!=0)
				{
					while(field.indexOf('\n') != -1)
					{			
						if(option.compareTo("-l ")==0)
							advop += option + "\"" + field.substring(0,field.indexOf('\n')).trim() + "\"" + " ** ";
						else if(option.compareTo("-v ")==0)
							{
							tmpStr = vOpCheck(field.substring(0,field.indexOf('\n')).trim());
							if(disposeFlag)								
								advop += option  + tmpStr + " ** ";
							else
								advop +="";
							}
						else
							advop += option + field.substring(0,field.indexOf('\n')).trim() + " ** ";
						field = field.substring(field.indexOf('\n') + 1);
					}
					if(option.compareTo("-l ")==0)
						advop += option + "\"" + field.trim() + "\"" + " ** ";
					else if(option.compareTo("-v ")==0)
							{
							tmpStr = vOpCheck(field.trim());
							if(disposeFlag)								
								advop += option  + tmpStr + " ** ";
							else
								advop +="";
							}
					else
						advop += option + field.trim() + " ** ";
					field = "";
				}
			}
		}else{
			advop+= "";
		}
	}


	public String vOpCheck(String str) // check -v option is in the format variable=value
	{
		System.out.println("in vopcheck");
		int eqI = str.indexOf('=');
		if(str.compareTo("")!=0)
		{
		if(eqI==-1)
		{
			disposeFlag = false;
			str = "";
		}else{
			str = str.substring(0,eqI) + "=\'" + str.substring(eqI+1) + "\'";
		}
		}
		return str;
	}

	public void getRunOptions(Checkbox cb, boolean state)
	{
		String run = "";
		String ojf = "";
		if(cb.getState()==true)
		{
			state=true;
			if(textFieldOJ.getText().trim().compareTo("")==0)
			{
				NoOldJournalDialog nojd = new NoOldJournalDialog(new Tetv3_gui());
				nojd.show();
				oldJournalFlag = false;
			}else{
				ojf = " -oj " + textFieldOJ.getText().trim() + " **! ";
				System.out.println("old journal file is " + ojf);
			
				for (int i=0; i<3; i++)
				{
					if(l.isIndexSelected(i)==true)
						run += l.getItem(i).substring(0,1) + " ";
				}
				run += textFieldM.getText();
				if(run.trim().compareTo("")==0)
				{
					noMRoptions = true;
					NoResumeRerunOptionsDialog nrrod = new NoResumeRerunOptionsDialog(new Tetv3_gui());
					nrrod.show();
					System.out.println("no m/r options");
				}else{
					run = run.trim().replace(' ', ',');
					if(cb.getLabel().compareTo("Resume")==0)
						run = " -m " + run + " **! ";
					else
						run = " -r " + run + " **! ";
					System.out.println("selected items are " + run);
				}
			}
			advop += run + ojf;
		}
	}

	public String setStrS(TextField tf, Checkbox cb, String option)
	{
		String field = tf.getText();

		if(field.compareTo("")>0)			//check textfield for a string		
		{
			if(cb.getState()==true)			//if checkbox is true
				strS += option + field.trim() + " " + " **! ";	//! indicates checkbox is true
			else
				strS += option + field.trim() + " " + " ** ";
		}else{
			strS = "";
		//	System.out.println("textfield " + option + " is empty " + field);
		}
		return strS;
	}

	public String setAdvOptions()
	{
	//	getFieldText(textFieldS, checkboxS,  "-s ");
		getFieldText(textFieldJ, checkboxJ,  "-j ");
		getFieldText(textFieldG, checkboxG,  "-g ");
		getFieldText(textFieldX, checkboxX,  "-x ");
		getFieldText(textFieldF, checkboxF,  "-f ");
		getFieldText(textFieldA, checkboxA,  "-a ");
		getFieldText(textFieldI, checkboxI,  "-i ");
		getAreaText(textAreaL, checkboxL,  "-l ");
		getAreaText(textAreaN, checkboxN,  "-n ");
		getAreaText(textAreaY, checkboxY,  "-y ");
		getAreaText(textAreaV, checkboxV,  "-v ");
		getRunOptions(checkboxR,stateR);
		getRunOptions(checkboxM,stateM);

		System.out.println("in setadvop " + advop);
		return advop;
	}

	public String sortString(String str, String option)
	{
		int opI, xxI, tmp;

		try
		{
			tmp = advop.indexOf(option);
			if(tmp >= 0)
			{
				opI = tmp;
			}else{
				opI = -1;
				str = "";
				stateSet = "";
			}
		}
		catch(RuntimeException e)
		{
			opI = -1;
			str = "";
			stateSet = "";
		}

		if(opI != -1)
		{
			String temp = advop.substring(opI);
			xxI = temp.indexOf("**");
			stateSet = temp.substring(xxI, xxI+3);
			str = temp.substring(3, xxI).trim();
		}
		return str;
	}

	public String sortString(String str, String option, String advOpt)
	{
		int opI, xxI, tmp;

		try
		{
			tmp = advOpt.indexOf(option);
			if(tmp >= 0)
			{
				opI = tmp;
			}else{
				opI = -1;
				str = "";
				stateSet = "";
			}
		}
		catch(RuntimeException e)
		{
			opI = -1;
			str = "";
			stateSet = "";
		}

		if(opI != -1)
		{
			String temp = advOpt.substring(opI);
			xxI = temp.indexOf("**");
			stateSet = temp.substring(xxI, xxI+3);
			str = temp.substring(3, xxI).trim();
		}
		System.out.println("stateSet is " + stateSet + " option is " + option); 
		return str;
	}

	public int noOfRows(String option)		//used for advop text areas
	{
		String tmp = advop;
		int count = 0;
		int opI = tmp.indexOf(option);
		while(opI != -1)
		{
			count++;
			tmp = tmp.substring(opI + 3);
			opI = tmp.indexOf(option);
		}
		return count;
	}
		

	public void setComp(Checkbox cb, Button b, TextField tf, boolean state)
	{
		if(stateSet.compareTo("**!")==0)
			state = true;
		else
			state = false;

		cb.setState(state);
		b.setEnabled(state);
		tf.setEnabled(state);
		tf.setEditable(state);
	}
	
	public void setComp(Checkbox cb, TextField tf, boolean state)
	{
		if(stateSet.compareTo("**!")==0)
			state = true;
		else
			state = false;

		cb.setState(state);
		tf.setEnabled(state);
		tf.setEditable(state);
	}

	public void setComp(Checkbox cb, TextArea ta)
	{
		boolean state;
		if(stateSet.compareTo("**!")==0)
			state = true;
		else
			state = false;
		cb.setState(state);
		ta.setEnabled(state);
		ta.setEditable(state);
	}

	public void setComp(Checkbox cb)
	{
		boolean state1 = cb.getState();
		textFieldOJ.setEnabled(state1);
		textFieldOJ.setEditable(state1);
		browse.setEnabled(state1);
	}

	public String listSelect(String str)
	{
		if(str.length()==1)
			str+= " ";
		if(str.startsWith("b ")||str.startsWith("b,"))
		{
			l.select(0);
			try{str=str.substring(2);}catch(RuntimeException e){}
			if(str.indexOf("e")==0)
			{
				l.select(1);
				try{str=str.substring(2);}catch(RuntimeException e){}
				if(str.indexOf("c")==0)
				{
					l.select(2);
					try{str=str.substring(2);}catch(RuntimeException e){}
				}
					
			}
		}
		else if(str.startsWith("e ")||str.startsWith("e,"))
		{
			l.select(1);
			try{str=str.substring(2);}catch(RuntimeException e){}
			if(str.indexOf("c")==0)
			{
				l.select(2);
				try{str=str.substring(2);}catch(RuntimeException e){}
			}
		}
		else if(str.startsWith("c ")||str.startsWith("c,"))
		{
			l.select(2);
			try{str=str.substring(2);}catch(RuntimeException e){}
		}
		return str="";
	}

	public void doTextArea(String str, String option, TextArea ta, Checkbox cb)
	{
		String temp = advop;
		for(int nor=0; nor < noOfRows(option); nor++)
		{
			str = sortString(str, option, temp);
			if(option.compareTo("-l ")==0)
				str = str.replace('\"', ' ').trim();
			if(option.compareTo("-v ")==0)
			{
				int i1 = str.indexOf("\'");
				int i2 = str.lastIndexOf("\'");
				str = str.substring(0,i1) + str.substring(i1+1,i2);
			}
			ta.append(str + "\n");
			temp = temp.substring(temp.indexOf(option) + 3);
		}
		if(noOfRows(option)==0)
			stateSet = "";
		setComp(cb, ta);
	}

	public synchronized void show()
	{
		Rectangle bounds = getParent().bounds();
		Rectangle abounds = bounds();
		frBounds = bounds;
	
		move(bounds.x + (bounds.width - abounds.width)/ 2,
			 bounds.y + (bounds.height - abounds.height)/2);


		try
		{
			FileInputStream fis = new FileInputStream("AdvOp");
			DataInputStream dis = new DataInputStream(fis);
			advop = dis.readLine();
			fis.close();

			FileInputStream fis2 = new FileInputStream("ScenF");
			DataInputStream dis2 = new DataInputStream(fis2);
			strS = dis2.readLine();
			fis2.close();

			strS = sortString(strS, "-s ", strS);
			textFieldS.setText(strS);
			setComp(checkboxS, buttonS, textFieldS, stateS);

			strM = sortString(strM, "-m ");
			strR = sortString(strR, "-r ");
			strOJ = sortString(strOJ, "-oj ");
			if(strM.compareTo("")==0)
			{
				if(strR.compareTo("")==0)
				{
					checkboxNm.setState(true);
					textFieldOJ.setText("");
				}else{
					strR = listSelect(strR);
					textFieldM.setText(strR);
					checkboxR.setState(true);
					setComp(checkboxR);
					if(strR.compareTo("")==0)
					{
						setCodeListComponents();
					}
				}		
			}else{
				strM = listSelect(strM);
				textFieldM.setText(strM);
				checkboxM.setState(true);
				setComp(checkboxM);
					if(strM.compareTo("")==0)
					{
						setCodeListComponents();
					}

			}
			textFieldOJ.setText(strOJ);

			strJ = sortString(strJ, "-j ");
			textFieldJ.setText(strJ);
			setComp(checkboxJ, buttonJ, textFieldJ, stateJ);
			strG = sortString(strG, "-g ");
			textFieldG.setText(strG);
			setComp(checkboxG, buttonG, textFieldG, stateG);
			strX = sortString(strX, "-x ");
			textFieldX.setText(strX);
			setComp(checkboxX, buttonX, textFieldX, stateX);
			strF = sortString(strF, "-f ");
			textFieldF.setText(strF);
			setComp(checkboxF, buttonF, textFieldF, stateF);
			strA = sortString(strA, "-a ");
			textFieldA.setText(strA);
			setComp(checkboxA, buttonA, textFieldA, stateA);
			strI = sortString(strI, "-i ");
			textFieldI.setText(strI);
			setComp(checkboxI, buttonI, textFieldI, stateI);
			doTextArea(strL, "-l ", textAreaL, checkboxL);
			doTextArea(strN, "-n ", textAreaN, checkboxN);
			doTextArea(strY, "-y ", textAreaY, checkboxY);
			doTextArea(strV, "-v ", textAreaV, checkboxV);
		}
		catch(IOException e)
		{
			System.out.println("Problems reading file " + e );
		}
		System.out.println(advop + " are the adv ops (op)");

		super.show();
	}

	public boolean handleEvent(Event evt)
	{
		if(evt.id == Event.WINDOW_DESTROY && evt.target == this)
			dispose();
		else
			return super.handleEvent(evt);
		return true;
	}

	class ROptions extends Panel
	{
		ROptions(String name)
		{
			setLayout(new GridLayout(4,1));
			Panel no1 = new Panel();
			add(no1);

			CheckboxGroup g1 = new CheckboxGroup();
			checkboxNm = new Checkbox("Normal", g1 , true);
			checkboxM  = new Checkbox("Resume", g1 , false);
			checkboxR  = new Checkbox("Re-run", g1 , false);
			no1.add(checkboxNm);
			no1.add(checkboxM);
			no1.add(checkboxR);

			Panel no2 = new Panel();
			add(no2);
			no2.setLayout(new FlowLayout(FlowLayout.LEFT));
			Label journal = new Label("Old Journal File");
			no2.add(journal);
			textFieldOJ = new TextField(55);
			no2.add(textFieldOJ);
			browse = new Button("Browse");
			no2.add(browse);
			Panel no3 = new Panel();
			add(no3);
			no3.setLayout(new FlowLayout(FlowLayout.LEFT));
			Panel no4 = new Panel();
			add(no4);
			no4.setLayout(new FlowLayout(FlowLayout.LEFT));
			CheckboxGroup g2 = new CheckboxGroup();
			checkboxOM = new Checkbox("tcc operation modes:", g2 , true);
			checkboxRC  = new Checkbox("test purpose result code names", g2 , false);
			no3.add(checkboxOM);
			no4.add(checkboxRC);
			l = new List(3, true);
			l.add("build",0);
			l.add("execute",1);
			l.add("clean",2);
			no3.add(l);
			textFieldM = new TextField(40);
			no4.add(textFieldM);
			browse.setEnabled(false);	
			l.setEnabled(false);
			textFieldOJ.setEnabled(false);
			textFieldOJ.setEditable(false);
			textFieldM.setEnabled(false);
			textFieldM.setEditable(false);
			checkboxOM.setEnabled(false);
			checkboxRC.setEnabled(false);
		}
	}


	class FOptions extends Panel
	{
		FOptions(String name)
		{
			setLayout(new FlowLayout(FlowLayout.LEFT));

			checkboxS = new Checkbox("-s   Scenario file                  ");
			add(checkboxS);
			textFieldS = new TextField(35);
			textFieldS.setEditable(stateS);
			textFieldS.setEnabled(stateS);
			add(textFieldS);
			buttonS = new Button("Browse");
			buttonS.setEnabled(stateS);
			add(buttonS);
			
			checkboxJ = new Checkbox("-j   Journal file                   ");
			add(checkboxJ);
			textFieldJ = new TextField(35);
			textFieldJ.setEditable(stateJ);
			textFieldJ.setEnabled(stateJ);
			add(textFieldJ);
			buttonJ = new Button("Browse");
			buttonJ.setEnabled(stateJ);
			add(buttonJ);

			checkboxG = new Checkbox("-g   Build mode configuration file  ");
			add(checkboxG);
			textFieldG = new TextField(35);
			textFieldG.setEditable(stateG);
			textFieldG.setEnabled(stateG);
			add(textFieldG);
			buttonG = new Button("Browse");
			buttonG.setEnabled(stateG);
			add(buttonG);

			checkboxX = new Checkbox("-x   Execute mode configuration file");
			add(checkboxX);
			textFieldX = new TextField(35);
			textFieldX.setEditable(stateX);
			textFieldX.setEnabled(stateX);
			add(textFieldX);
			buttonX = new Button("Browse");
			buttonX.setEnabled(stateX);
			add(buttonX);

			checkboxF = new Checkbox("-f   Clean mode configuration file  ");
			add(checkboxF);
			textFieldF = new TextField(35);
			textFieldF.setEditable(stateF);
			textFieldF.setEnabled(stateF);
			add(textFieldF);
			buttonF = new Button("Browse");
			buttonF.setEnabled(stateF);
			add(buttonF);

		}

	}


	class DOptions extends Panel
	{
		DOptions(String name)
		{
			setLayout(new FlowLayout(FlowLayout.LEFT));

			checkboxA = new Checkbox("-a Execution Directory  ");
			add(checkboxA);
			textFieldA = new TextField(35);
			textFieldA.setEditable(stateA);
			textFieldA.setEnabled(stateA);
			add(textFieldA);
			buttonA = new Button("Browse");
			buttonA.setEnabled(stateA);
			add(buttonA);

			checkboxI = new Checkbox("-i Journal Directory    ");
			add(checkboxI);
			textFieldI = new TextField(35);
			textFieldI.setEditable(stateI);
			textFieldI.setEnabled(stateI);
			add(textFieldI);
			buttonI = new Button("Browse");
			buttonI.setEnabled(stateI);
			add(buttonI);

		}
	}

	class MOptions extends Panel
	{
		MOptions(String name)
		{

		//	setLayout(new FlowLayout(FlowLayout.LEFT));
			setLayout(new GridLayout(6,2));
			checkboxL = new Checkbox("-l Process Scenario line        ");
			add(checkboxL);
			textAreaL = new TextArea("",2,40,TextArea.SCROLLBARS_VERTICAL_ONLY);
			textAreaL.setEditable(stateL);
			textAreaL.setEnabled(stateL);
			add(textAreaL);

			checkboxV = new Checkbox("-v set configuration variable   ");
			add(checkboxV);
			textAreaV = new TextArea("",2,40,TextArea.SCROLLBARS_VERTICAL_ONLY);
			textAreaV.setEditable(stateV);
			textAreaV.setEnabled(stateV);
			add(textAreaV);

			add(new Label("TEST CASE ADVANCED OPTIONS"));
			add(new Label(""));
			
			CheckboxGroup g = new CheckboxGroup();		

			checkboxNone = new Checkbox("None",g,true);
			add(checkboxNone);
			add(new Label(""));		

			checkboxN = new Checkbox("-n Do not process these test cases",g,false);
			add(checkboxN);
			textAreaN = new TextArea("",2,40,TextArea.SCROLLBARS_VERTICAL_ONLY);
			textAreaN.setEditable(stateN);
			textAreaN.setEnabled(stateN);
			add(textAreaN);

			checkboxY = new Checkbox("-y Only process these test cases  ",g,false);
			add(checkboxY);
			textAreaY = new TextArea("",2,40,TextArea.SCROLLBARS_VERTICAL_ONLY);
			textAreaY.setEditable(stateY);
			textAreaY.setEnabled(stateY);
			add(textAreaY);

		}
	}


//---------Wrong Format dialog - variable!=value-----------------------------------

	class WrongFormatDialog extends Dialog
	{
		public WrongFormatDialog(Frame parent)
		{
			super(parent, "Error", true);
			Panel p1 = new Panel();
			p1.add(new Label("The configuration variable has been set incorrectly."));
			p1.add(new Label("It should be in the format:"));
			p1.add(new Label("variable=value"));
			p1.add(new Label("To change to the correct format, select:"));
			p1.add(new Label("\'More Options | set configuration variable\'"));
			add("Center", p1);

			Panel p2 = new Panel();
			p2.add(new Button("OK"));
			add("South",p2);
			setSize(300,200);

		}
	
//---------show and centrally locate dialog----------------------------------------------

		public synchronized void show()
		{
			Rectangle abounds = bounds();
	
			move(frBounds.x + (frBounds.width - abounds.width)/ 2,
				 frBounds.y + (frBounds.height - abounds.height)/2);

			super.show();
		}

//---------handle actions----------------------------------------------------------------

		public boolean action(Event evt, Object arg)
		{
			if(arg.equals("OK"))
			{
				dispose();
				return true;
			}
			return false;
		}

		public boolean handleEvent(Event evt)
		{
			if(evt.id == Event.WINDOW_DESTROY && evt.target == this)
				dispose();
			else
				return super.handleEvent(evt);
			return true;
		}
	}
//---------Warns if file already/does not exist/s----------------------------------------

	class FileExistsDialog extends Dialog
	{
		public FileExistsDialog(Frame parent)
		{
			super(parent, "Error", true);
			Panel p1 = new Panel();
			p1.add(new Label(textFieldJ.getText() + " already exists."));
			p1.add(new Label("Please choose a new file for the results:"));
			p1.add(new Label("Press 'Alternative file settings' and enter the path"));
			p1.add(new Label("and filename in the '-j Journal file' text field")); 
			add("Center", p1);

			Panel p2 = new Panel();
			p2.add(new Button("OK"));
			add("South",p2);
			setSize(300,200);

		}
	
		public FileExistsDialog(Frame parent, int i)
		{
			super(parent, "Warning!", true);
			Panel p1 = new Panel();
			p1.add(new Label("The old journal file specified does NOT exist"));
			p1.add(new Label("Choose an old journal file by selecting:"));
			p1.add(new Label("\'Run Options | Browse\'"));
			add("Center", p1);

			Panel p2 = new Panel();
			p2.add(new Button("OK"));
			add("South",p2);
			setSize(300,150);
		}

//---------show and centrally locate dialog----------------------------------------------

		public synchronized void show()
		{
			Rectangle abounds = bounds();
	
			move(frBounds.x + (frBounds.width - abounds.width)/ 2,
				 frBounds.y + (frBounds.height - abounds.height)/2);

			super.show();
		}

//---------handle actions----------------------------------------------------------------

		public boolean action(Event evt, Object arg)
		{
			if(arg.equals("OK"))
			{
				dispose();
				return true;
			}
			return false;
		}

		public boolean handleEvent(Event evt)
		{
			if(evt.id == Event.WINDOW_DESTROY && evt.target == this)
				dispose();
			else
				return super.handleEvent(evt);
			return true;
		}
	}

//---------No resume/re-run options specified dialog-------------------------------------

	class NoResumeRerunOptionsDialog extends Dialog
	{
		public NoResumeRerunOptionsDialog(Frame parent)
		{
			super(parent, "Error", true);
			Panel p1 = new Panel();
			p1.add(new Label("No Resume/Re-run options have been specified"));
			p1.add(new Label("Please select tcc operation modes from \'Run Options\'"));
			p1.add(new Label("OR"));
			p1.add(new Label("Enter test purpose result codes (separated by white space)"));
			add("Center", p1);

			Panel p2 = new Panel();
			p2.add(new Button("OK"));
			add("South",p2);
			setSize(350,200);

		}
	
//---------show and centrally locate dialog----------------------------------------------

		public synchronized void show()
		{
			Rectangle abounds = bounds();
	
			move(frBounds.x + (frBounds.width - abounds.width)/ 2,
				 frBounds.y + (frBounds.height - abounds.height)/2);

			super.show();
		}

//---------handle actions----------------------------------------------------------------

		public boolean action(Event evt, Object arg)
		{
			if(arg.equals("OK"))
			{
				dispose();
				return true;
			}
			return false;
		}

		public boolean handleEvent(Event evt)
		{
			if(evt.id == Event.WINDOW_DESTROY && evt.target == this)
				dispose();
			else
				return super.handleEvent(evt);
			return true;
		}
	}

//---------No old journal Dialog - error with test scenarioFile-----------------------------------

	class NoOldJournalDialog extends Dialog
	{
		public NoOldJournalDialog(Frame parent)
		{
			super(parent, "Warning!", true);
			Panel p1 = new Panel();
			p1.add(new Label("No old journal file has been specified"));
			p1.add(new Label("Choose an old journal file by selecting:"));
			p1.add(new Label("\'Run Options | Old Journal File\'"));
			add("Center", p1);

			Panel p2 = new Panel();
			p2.add(new Button("OK"));
			add("South",p2);
			setSize(300,150);
		}

	
//---------show and centrally locate dialog----------------------------------------------

		public synchronized void show()
		{
			Rectangle abounds = bounds();
	
			move(frBounds.x + (frBounds.width - abounds.width)/ 2,
				 frBounds.y + (frBounds.height - abounds.height)/2);

			super.show();
		}

//---------handle actions----------------------------------------------------------------

		public boolean action(Event evt, Object arg)
		{
			if(arg.equals("OK"))
			{
				dispose();
				return true;
			}
			return false;
		}

		public boolean handleEvent(Event evt)
		{
			if(evt.id == Event.WINDOW_DESTROY && evt.target == this)
				dispose();
			else
				return super.handleEvent(evt);
			return true;
		}
	}
 
//---------Advanced options components---------------------------------------------------

	String advop = "";		// string of advanced options
	String stateSet = "";		// If stateSet = **! setComp = true 
					// If stateSet = **  setComp = false
	boolean disposeFlag = true;	// do not dispose advanced options frame if -v options in wrong format
	boolean oldJournalFlag = true;	// do not dispose advanced options frame if no journal file has been selected in resume/rerun mode
	boolean noMRoptions = false;	// do not dispose advanced options frame if no resume/rerun options have been specified
	List l;				// list of currently selected operation modes used to rerun/resume

	String strS = "";
	String strJ = "";
	String strG = "";
	String strX = "";
	String strF = "";
	String strA = "";
	String strI = "";
	String strL = "";
	String strN = "";
	String strY = "";
	String strV = "";
	String strM = "";
	String strR = "";
	String strOJ = "";	

	boolean stateS = false;
	boolean stateJ = false;
	boolean stateG = false;
	boolean stateX = false;
	boolean stateF = false;
	boolean stateA = false;
	boolean stateI = false;
	boolean stateL = false;
	boolean stateN = false;
	boolean stateY = false;
	boolean stateV = false;
	boolean stateR = false;
	boolean stateM = false;
	boolean stateNm = false;

	Checkbox checkboxNm;
	Checkbox checkboxM;
	Checkbox checkboxR;
	Checkbox checkboxOM;
	Checkbox checkboxRC;

	Checkbox checkboxS;
	Checkbox checkboxJ;
	Checkbox checkboxG;
	Checkbox checkboxX;
	Checkbox checkboxF;
	Checkbox checkboxA;
	Checkbox checkboxI;
	Checkbox checkboxL;
	Checkbox checkboxN;
	Checkbox checkboxY;
	Checkbox checkboxV;
	Checkbox checkboxNone;

	TextField textFieldOJ;
	TextField textFieldM;
	TextField textFieldS;
	TextField textFieldJ;
	TextField textFieldG;
	TextField textFieldX;
	TextField textFieldF;
	TextField textFieldA;
	TextField textFieldI;

	TextArea textAreaL;
	TextArea textAreaN;
	TextArea textAreaY;
	TextArea textAreaV;

	Button buttonS;
	Button buttonJ;
	Button buttonG;
	Button buttonX;
	Button buttonF;
	Button buttonA;
	Button buttonI;
	Button browse;

	Rectangle frBounds;
}




