
##
## Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
##
## All rights reserved. No part of this source code may be reproduced,
## stored in a retrieval system, or transmitted, in any form or by any
## means, electronic, mechanical, photocopying, recording or otherwise,
## except as stated in the end-user licence agreement, without the prior
## permission of the copyright owners.
##
##
## A Semi portable makefile. 

CFLAGS= 

# SGS Definitions

# The C compiler name
# CC = cc

# GNU
CC = gcc

# win32, using the MS C compiler, switch off the copyright notice
#CC = cl -nologo

# object filenames 
O = .o

# win32 systems use .obj
#O = .obj

# exe filenames
# For UNIX systems this should have no value
E = 

# win32 systems use .exe
#E = .exe

#script filenames (korn or mks shell scripts)
# for UNIX systems this should have no value
K =

# win32 systems use .bat
#K = .ksh

# file removal
RM = rm -f


#### no changes should be needed below this point


all:	prereq rpt$E rptm$E  TETv3_gui.class gtcc.vars

prereq:	
	@if test "$$TET_ROOT" = "" ; \
	 then  echo "TET_ROOT must be defined in the environment" && exit 1; \
	fi

TETv3_gui.class: AboutDialog.java AdvOptions.java FindDialog.java FindReplace.java FindReplaceEngine.java  QuitDialog.java ReplaceConfirmDialog.java ReplaceDialog.java Tetv3_gui.java JavaPad.java
	javac AboutDialog.java AdvOptions.java FindDialog.java FindReplace.java FindReplaceEngine.java  QuitDialog.java ReplaceConfirmDialog.java ReplaceDialog.java Tetv3_gui.java JavaPad.java

gtcc.vars:	
	@echo "@ECHO OFF" > $@
	@echo "SET OLDERPATH=%PATH%" >> $@
	@echo "SET PATH=%PATH%;$(TET_ROOT)/bin" >> $@
	@echo "SET TET_ROOT=$(TET_ROOT)" >> $@
	@echo "java Tetv3_gui" >> $@
	@echo "SET PATH=%OLDERPATH%" >> $@

rpt$E:	rpt.c getopt$O
	$(CC) $(CFLAGS) -c rpt.c
	$(CC) $(CFLAGS) -o rpt rpt$O getopt$O

rptm$E:	rptm.c getopt$O
	$(CC) $(CFLAGS) -c rptm.c
	$(CC) $(CFLAGS) -o rptm rptm$O getopt$O

getopt$O:	getopt.c
	$(CC) $(CFLAGS) -c getopt.c

install: rpt$E rptm$E Tetv3_gui.class
	cp rptm$E $(TET_ROOT)/bin/
	cp rpt$E $(TET_ROOT)/bin/
	cp *.class $(TET_ROOT)/bin/
	cp gtcc.vars $(TET_ROOT)
	cp gtcc$K $(TET_ROOT)/bin/gtcc$K
	cp AdvOp TSop $(TET_ROOT)
	cp atlantis.gif $(TET_ROOT)

clean:
	$(RM) *$O rpt$E rptm$E *.class gtcc.vars

clobber: clean
	$(RM) $(TET_ROOT)/bin/rptm$E $(TET_ROOT)/bin/rpt$E  \
	$(TET_ROOT)/bin/*.class $(TET_ROOT)/bin/gtcc$K \ 
	$(TET_ROOT)/AdvOp $(TET_ROOT)/TSop $(TET_ROOT)/atlantis.gif

